/*
 * PgImpSurf_CP.java
 *
 * Created on December 5, 2004, 6:20 PM
 */

package Grapher.geom;

import java.awt.*;

import java.awt.event.*;
import jv.object.PsDebug;
import jv.object.PsPanel;
import jv.object.PsUpdateIf;
import jv.project.PgGeometryIf;
import Grapher.util.*;
/**
 * Control panel for implicitly defined surfaces from PgImpSurf
 *
 * @author David Lippman
 * @version 1.0.122204
 */
public class PgImpSurf_CP extends PsPanel implements ActionListener, FocusListener {
        protected	PgImpSurf                               m_PgImpSurf;
        protected       PsPanel                                 m_pFunc;
	protected	PsPanel					m_pDomain;
        protected       PsPanel                                 m_pParams;
        protected       TextField                               m_tText;
    
    /** Creates a new instance of PgImpSurf_CP */
    public PgImpSurf_CP() {
        super();
        if (getClass() == PgImpSurf_CP.class) {
            init();
        }
    }
    
    /** Initializes the panel */
     public void init() {
		super.init();
		addTitle("Graph");
             
                m_pFunc = new PsPanel();
                m_pFunc.setLayout(new GridLayout(1, 1));
                add(m_pFunc);
                
                m_pParams = new PsPanel();
                add(m_pParams);
                
		m_pDomain = new PsPanel();
  		add(m_pDomain);
		
		addLine(1);
    }
    
    /** Sets parent, creates textfield for equation entry, and sets up domain */
    public void setParent(PsUpdateIf parent) {
		super.setParent(parent);
             
		m_PgImpSurf = (PgImpSurf)parent;
                
                setTitle("Implicit Surf " + m_PgImpSurf.getName());
                
                m_tText = new TextField();
                if (m_PgImpSurf.coords == m_PgImpSurf.TYPE_IMPSURF) {
                    m_tText.setText("x^2+y^2+z^2=16");
                } else if (m_PgImpSurf.coords == m_PgImpSurf.TYPE_IMPCYL) {
                    m_tText.setText("r=4");
                } else if (m_PgImpSurf.coords == m_PgImpSurf.TYPE_IMPSPH) {
                    m_tText.setText("r=4");
                }  
                m_PgImpSurf.setEqn(m_tText.getText());
                
                
                m_tText.addActionListener(this);
                m_tText.addFocusListener(this);
               
                m_pFunc.add(m_tText);
                                
//              m_pFunc.add(m_PgImpSurf.m_func2.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                
                m_pParams.add(m_PgImpSurf.m_params.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));
                
                m_pDomain.add(m_PgImpSurf.m_domain.assureInspector(PsPanel.INFO,PsPanel.INFO_EXT));

        }
    
    /** Handles update calls.  Domain sends its own updates, so this method does little */
    public boolean update(Object event) {
		if (PsDebug.NOTIFY) PsDebug.notify("isShowing = "+isShowing());
		return super.update(event);
	}
    
    /** Handles changes to the textfield.  Calls setEqn */
    public void actionPerformed(ActionEvent event) {
		
		Object source = event.getSource();
                if (source == m_tText) {
                    m_PgImpSurf.setEqn(m_tText.getText());
                }
    }
    
    public void focusGained(FocusEvent e) {
    }
    
    public void focusLost(FocusEvent event) {
        Object source = event.getSource();
                if (source == m_tText) {
                    m_PgImpSurf.setEqn(m_tText.getText());
                }
    }
    
}
